//More infos on:
//www.homofaciens.de/technics-machines-3D-printer-Zonestar-QA_en.htm

$fn=100;



cover();
//belt_tensioner();

/*
translate([0, 5, 0]){
  enforcement(0);
}
translate([-17, 50, 0]){
  enforcement(1);
}
translate([-80, 50, 0]){
  enforcement(1);
}
translate([-17, 100, 0]){
  enforcement(1);
}
translate([-80, 100, 0]){
  enforcement(1);
}

translate([-15, 0, 0]){
  enforcement(2);
}
translate([-82, 0, 0]){
  mirror([1, 0, 0]){
    enforcement(2);
  }
}
*/

//cable_chain();
/*
translate([37, 0, 16*0]){
  mirror([0, 0, 1]){
    cable_chain(1);
  }
}
*/



module enforcement(OnlyAngle=0){
  holes_d = 4.5;
  e_length = 80+258*0;
  e_height = 80;
  e_radius = 20;
  e_cross_x = 20;
  e_cross_y = 40;
  e_screw_edge = 13;
  
  e_length_link = 258-2*e_length-1;
  
  screw_offset = 15+5;
  screw_distance_y = sqrt(38*38-screw_offset*screw_offset);
  screw_edge = 20;
  washer_d = 15;

  e_link_plate_l = screw_edge * 2 + 20;
  e_link_plate_wall = 2;
  e_link_plate_height = 7;

  
  link_screw_distance = 25;
  link_tolerance = 1;

  if(OnlyAngle == 0){
    //Central link
    translate([-50, 0, e_cross_x/2]){
      difference(){
        cube(size=[e_length_link, e_cross_y, e_cross_x], center=true);
        translate([e_length_link/2-screw_edge, link_screw_distance/2, 0]){
          cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
        }
        translate([e_length_link/2-screw_edge, -link_screw_distance/2, 0]){
          cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
        }
        translate([-e_length_link/2+screw_edge, link_screw_distance/2, 0]){
          cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
        }
        translate([-e_length_link/2+screw_edge, -link_screw_distance/2, 0]){
          cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
        }
      }
    }
  }
  
  if(OnlyAngle == 1){
    //Link plates central link
    translate([0, 0, e_link_plate_wall/2]){
      difference(){
        cube(size=[e_link_plate_l, e_cross_y+link_tolerance, e_link_plate_wall], center=true);
        translate([-screw_edge, link_screw_distance/2, 0]){
          long_hole(holes_d, 2, 6);
        }
        translate([-screw_edge, -link_screw_distance/2, 0]){
          long_hole(holes_d, 2, 6);
        }
        translate([screw_edge, link_screw_distance/2, 0]){
          long_hole(holes_d, 2, 6);
        }
        translate([screw_edge, -link_screw_distance/2, 0]){
          long_hole(holes_d, 2, 6);
        }
      }
      translate([0, (e_cross_y+link_tolerance+e_link_plate_wall)/2,(e_link_plate_height-e_link_plate_wall)/2]){
        cube(size=[e_link_plate_l, e_link_plate_wall, e_link_plate_height], center=true);
      }
      translate([0, -(e_cross_y+link_tolerance+e_link_plate_wall)/2,(e_link_plate_height-e_link_plate_wall)/2]){
        cube(size=[e_link_plate_l, e_link_plate_wall, e_link_plate_height], center=true);
      }
    }
  }
  
  if(OnlyAngle == 2){
    //Angle
    translate([0, 0, e_cross_y/2]){
      difference(){
        union(){
          cube(size=[e_length-e_radius, e_height, e_cross_y], center=true);
          translate([e_length/2, e_radius/2, 0]){
            cube(size=[e_cross_x, e_height-e_radius, e_cross_y], center=true);
          }
          translate([(e_length-e_radius)/2, e_radius-e_height/2, 0]){
            cylinder(r=e_radius, h=e_cross_y, center=true);
          }
        }
        translate([-e_cross_x, e_cross_x, 0]){
          union(){
            cube(size=[e_length-e_radius, e_height, e_cross_y*1.1], center=true);
            translate([e_length/2, e_radius/2, 0]){
              cube(size=[e_cross_x, e_height-e_radius, e_cross_y*1.1], center=true);
            }
            translate([(e_length-e_radius)/2, e_radius-e_height/2, 0]){
              cylinder(r=e_radius, h=e_cross_y*1.1, center=true);
            }
          }
        }
        //Link screw holes
        translate([screw_edge-(e_length-e_cross_x)/2, (e_cross_x-e_height)/2, link_screw_distance/2]){
          rotate([90, 0, 0]){
            cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
          }
        }
        translate([screw_edge-(e_length-e_cross_x)/2, (e_cross_x-e_height)/2, -link_screw_distance/2]){
          rotate([90, 0, 0]){
            cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
          }
        }
        //Mount screw holes
        translate([e_length/2, e_height/2-e_screw_edge, screw_offset/2]){
          rotate([0, 90, 0]){
            cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
            translate([0, 0, -5]){
              cylinder(d=washer_d, h=e_cross_x*1.1, center=true);
            }
          }
        }
        translate([e_length/2, e_height/2-screw_distance_y-e_screw_edge, -screw_offset/2]){
          rotate([0, 90, 0]){
            cylinder(d=holes_d, h=e_cross_x*1.1, center=true);
            translate([0, 0, -5]){
              cylinder(d=washer_d, h=e_cross_x*1.1, center=true);
            }
          }
        }
      }
    }
  }

  
}

module long_hole(diameter = 4, length = 2, height = 6){
  translate([length/2, 0, 0]){
    cylinder(d=diameter, h=height, center=true);
  }
  cube(size=[length, diameter, height], center=true);
  translate([-length/2, 0, 0]){
    cylinder(d=diameter, h=height, center=true);
  }
}

module belt_tensioner(){
  t_wall = 5;
  t_height = 57;
  t_width = 36;
  t_length = 50;
  cut_edge = 22;
  bearing_y = 9;
  bearing_z = 15;
  screw_distance = 44;
  screw_edge = 7;
  screw_hole = 5;
  nut_hole = 7.66;
  
  z_cut_w = 25;
  z_cut_pos = 25;
  
  translate([0, 0, (t_length+t_wall)/2]){
    difference(){
      cube(size=[t_height+2*t_wall, t_width+2*t_wall, t_length+t_wall], center=true);
      translate([0, 0, t_wall/2+0.1]){
        cube(size=[t_height, t_width, t_length], center=true);
      }
      translate([0, t_width/2-bearing_y-2, -(t_length)/2]){
        cube(size=[cut_edge, cut_edge, t_wall*1.1], center=true);
      }
      //Z cut
      translate([0, -t_width/2+z_cut_w/2, -(t_wall)/2+z_cut_pos]){
        cube(size=[t_height*2, z_cut_w, t_length], center=true);
      }
      translate([0, -t_width/2+z_cut_w/2, -(t_wall+t_length)/2+z_cut_pos]){
        rotate([0, 90, 0]){
          cylinder(d=z_cut_w, h=t_width*2, center=true);
        }
      }
      //screw hole bearing
      translate([0, 0, bearing_z-(t_length+t_wall)/2]){
        rotate([90, 0, 0]){
          cylinder(d=4, h=t_width * 2, center=true);
        }
      }
      
      //screws tentioning
      translate([screw_distance/2, t_width/2-screw_edge, -(t_length)/2]){
        cylinder(d=screw_hole, h=t_wall*1.1, center=true);
      }
      translate([-screw_distance/2, t_width/2-screw_edge, -(t_length)/2]){
        cylinder(d=screw_hole, h=t_wall*1.1, center=true);
      }
      translate([-screw_distance/2, t_width/2-screw_edge, -(t_length)/2+t_wall*1/3]){
        cylinder($fn=6, d=nut_hole, h=t_wall, center=true);
      }
      translate([screw_distance/2, t_width/2-screw_edge, -(t_length)/2+t_wall*1/3]){
        cylinder($fn=6, d=nut_hole, h=t_wall, center=true);
      }
    }
  }
}

module cover(){
  M3_hole = 2.8;
  edge_w = 7;

  cover_wall = 2;
  cover_h1 = 50;
  cover_h2 = 30;
  cover_l = 100 + 2 * cover_wall;
  cover_w = 42 + 2 * cover_wall;

  
  cut_l = 90;
  cut_h = 45;
  cut_z = -(cover_h1+cover_h2-cut_h)/2 + edge_w;
  cable_d = 7;
  cable_x = -15;
  cable_y = -34;
  cable_z = 0;
  
  screw_distance = 40;

  tolerance = 1;
  cover_f_l = 100 + 4 * cover_wall + tolerance;
  cover_f_w = 65 - cover_w;
  cover_f_h = cut_h + 2 * edge_w + 2 * cover_wall + tolerance;

  plug_w = 46;
  plug_h = 20;
  plug_y = -10;
  plug_z = 20;
  
  enforce_x = -10;
  enforce_h = 7;


  //Front body
  //translate([0, 42+0, -40.5])
  //rotate([90, 0, 0])
  translate([0, 80, (cover_f_w)/2]){
    difference(){
      cube(size=[cover_f_l, cover_f_h, cover_f_w], center=true);      
      translate([0, 0, cover_wall]){
        cube(size=[cover_f_l-2*cover_wall, cover_f_h-2*cover_wall, cover_f_w], center=true);      
      }
      translate([plug_z, plug_y, 0]){
        cube(size=[plug_w, plug_h, cover_f_w*1.1], center=true);      
      }
      translate([0, screw_distance/2, (cover_f_w-edge_w)/2]){
        rotate([0, 90, 0]){
          cylinder(d=4, h=cover_f_l*1.1, center=true);
        }
      }
      translate([0, -screw_distance/2, (cover_f_w-edge_w)/2]){
        rotate([0, 90, 0]){
          cylinder(d=4, h=cover_f_l*1.1, center=true);
        }
      }
    }
    translate([enforce_x, 0, (enforce_h - cover_f_w)/2+cover_wall]){
      cube(size=[cover_wall, cover_f_h, enforce_h], center=true);      
    }
  }

  //Main body
  translate([0, 35, 0]){
    bridge_post(height=52, overhang = 17);
  }
  translate([16, 35, 0]){
    bridge_post(height=52, overhang = 17);
  }
  translate([32, 35, 0]){
    bridge_post(height=52, overhang = 17);
  }
  translate([-16, 35, 0]){
    bridge_post(height=52, overhang = 17);
  }
  translate([-32, 35, 0]){
    bridge_post(height=52, overhang = 17);
  }
  
  translate([0, 0, (cover_h1+cover_h2)/2]){
    
    
    //upper edge
    translate([0, cover_w/2, cut_z+cut_h/2+edge_w]){
      rotate([0, 180, 0]){
        linear_extrude(height=edge_w, scale=[1, 0]){
          translate([0, edge_w/2, 0]){
            square(size=[cut_l, edge_w], center=true);
          }
        }
      }
    }

    //left wall
    translate([(cover_l-edge_w)/2, (cover_w+edge_w)/2, cut_z]){
      difference(){
        cube(size=[edge_w, edge_w, cut_h+2*edge_w], center=true);
        translate([0, 0, screw_distance/2]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=edge_w*11, center=true);
          }
        }
        translate([0, 0, -screw_distance/2]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=edge_w*11, center=true);
          }
        }
      }
    }
    //right wall
    translate([-(cover_l-edge_w)/2, (cover_w+edge_w)/2, cut_z]){
      difference(){
        cube(size=[edge_w, edge_w, cut_h+2*edge_w], center=true);
        translate([0, 0, screw_distance/2]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=edge_w*11, center=true);
          }
        }
        translate([0, 0, -screw_distance/2]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=edge_w*11, center=true);
          }
        }
      }
    }
    //bottom wall
    translate([0, (cover_w+edge_w)/2, -(cover_h1+cover_h2-edge_w)/2]){
      cube(size=[cover_l-2*edge_w, edge_w, edge_w], center=true);
    }

    //body
    difference(){
      cube(size=[cover_l, cover_w, cover_h1 + cover_h2], center=true);
      translate([0, 0, cover_wall]){
        cube(size=[cover_l-2*cover_wall, cover_w-2*cover_wall, cover_h1+cover_h2], center=true);
      }
      translate([0, cover_w/2, cut_z]){
        cube(size=[cut_l, cover_wall * 2.5, cut_h], center=true);
      }
      //Cut DC cable out
      translate([-(cover_l)/2, cable_x, cable_y]){
        rotate([0, 90, 0]){
          cylinder(d=cable_d, h=cover_wall*2.5, center=true);
        }
      }
    }
  }
  
}

module bridge_post(height = 30, overhang = 15){
  edge = 5;
  
  brim = edge * 2;
  brim_h = 0.35;
  
  translate([0, 0, brim_h/2]){
    cube(size=[brim, brim, brim_h], center=true);
  }
  translate([0, 0, (height-edge)/2]){
    cube(size=[edge, edge, height-edge], center=true);
  }
  translate([0, -(overhang-edge)/2, height-edge]){
    linear_extrude(height=edge, scale=[0, 1]){
      square(size=[edge, overhang], center=true);
    }
  }
  translate([0, -edge/2, height-edge]){
    rotate([180, 0, 0]){
      linear_extrude(height=overhang-edge, scale=[1, 0]){
        translate([0, (overhang-edge)/2, 0]){
          square(size=[edge, overhang-edge], center=true);
        }
      }
    }
  }

}



module cable_chain(mirrorStop = 0){
    
  width=25;
  height=16;
  length=37.5;
  wall=2;
  tolerance=0.6;
  tolerance_w=0.6;
  tolerance_stop = 0.4;
  overlap=0.5;
  link_w=10;
  l_stop=length/2-(link_w/2-(length/2-height))-tolerance_stop;
  
  
  l=length-height;
  
  scale_a = height/(cos(180/8)*height);
  
  x1=l/2;
  y1=0;
  x2=l/2;
  y2=height/2;
  x3=l_stop;
  y3=height/2;
  x4=l_stop;
  y4=height/3;
  
  for(i=[0:1:1]){
    mirror([0, i, 0]){
      translate([0, -(width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          difference(){
            union(){
              translate([(l/2-overlap)/2, 0, 0]){
                cube(size=[l/2+overlap, height, wall], center=true);
              }
              //stopper
              mirror([0, mirrorStop, 0]){
                translate([l_stop/2, -(height)/4, 0]){
                  cube(size=[l_stop, height/2, wall], center=true);
                }
              }
              translate([-(l/2-overlap)/2, 0, wall+tolerance_w]){
                cube(size=[l/2+overlap, height, wall], center=true);
              }            
              translate([0, -height/2, -wall/2]){
                linear_extrude(height=wall){
                  polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
                }
              }
              mirror([0,1,0]){
                translate([0, -height/2, -wall/2]){
                  linear_extrude(height=wall){
                    polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
                  }
                }
              }              
              translate([-l/2, 0, wall+tolerance_w]){
                scale([1, scale_a]){
                  rotate([0, 0, 360/8/2]){
                    cylinder($fn=8, d=height, h=wall, center=true);
                  }
                }
              }
              translate([l/2, 0, wall]){
                cylinder(d1=height/2, d2=height/2-wall, h=wall, center=true);
              }
            }
            translate([-l/2, 0, wall+tolerance_w]){
              cylinder(d1=height/2, d2=height/2-wall, h=wall+0.025, center=true);
            }
          }
        }
      }
    }
  }

    
    translate([0, 0, wall/2]){
      cube(size=[link_w, width, wall], center=true);
    }
    difference(){
      translate([-link_w/4+overlap/2, (width-wall+tolerance_w)/2, height/2]){
        cube(size=[link_w/2+overlap, wall+tolerance_w, height], center=true);      
      }
      translate([-l/2, (width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=wall*2.1, center=true);
        }
      }
    }
    difference(){
      translate([-link_w/4+overlap/2, -(width-wall+tolerance_w)/2, height/2]){
        cube(size=[link_w/2+overlap, wall+tolerance_w, height], center=true);      
      }
      translate([-l/2, -(width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=wall*2.1, center=true);
        }
      }
    }
//  }
  
}
